package com.otk.application;

import java.io.InputStream;
import java.net.URL;
import java.util.Properties;

import com.otk.application.error.UnexpectedError;

public abstract class AbstractBuildProperties {

	private Properties properties = new Properties();

	protected abstract URL getURL();

	public AbstractBuildProperties() {
		URL url = getURL();
		if (url != null) {
			InputStream stream = null;
			try {
				stream = url.openStream();
				properties.load(stream);
			} catch (Exception e) {
				throw new UnexpectedError("Failed to read build properties resource: " + e.toString(), e);
			} finally {
				if (stream != null) {
					try {
						stream.close();
					} catch (Throwable ignore) {
					}
				}
			}
		}
	}

	public int getBuildNumber() {
		return Integer.valueOf(properties.getProperty("buildId", "-1"));
	}

	public String getVersion() {
		return properties.getProperty("appVersion", "UNKNOWN");
	}

}
