package com.otk.application.audio;

/**
 * Represents a track on which only one sound can be played at a time.
 * 
 * @author olitank
 *
 */
public class SoundTrack {
	public final static SoundTrack DEFAULT = new SoundTrack("DEFAULT");

	/**
	 * The name of the sound track.
	 */
	String name;

	/**
	 * Whether the currently playing sound interruption has been requested or not.
	 */
	boolean requestingIntrerruption = false;

	/**
	 * Whether a sound is being played on this track or not.
	 */
	boolean rotating = false;

	/**
	 * the current or last sound played on this track.
	 */
	Sound lastSoundData;

	/**
	 * The thread responsible for playing this track current sound.
	 */
	Thread clipRunner;

	/**
	 * Constructs a sound track having the given name.
	 * 
	 * @param name
	 *            The {@link #name} value.
	 */
	public SoundTrack(String name) {
		super();
		this.name = name;
	}

	@Override
	public String toString() {
		return "SoundTrack [name=" + name + "]";
	}

}