package com.otk.application.error;

/**
 * This class represents an error that is not supposed to occur. it should be
 * handled as a bug.
 * 
 * @author olitank
 *
 */
public class UnexpectedError extends AbstractApplicationError {

	private static final long serialVersionUID = 1L;

	public UnexpectedError() {
		super();
	}

	public UnexpectedError(String message, Throwable cause) {
		super(message, cause);
	}

	public UnexpectedError(String message) {
		super(message);
	}

	public UnexpectedError(Throwable cause) {
		super(cause);
	}

	@Override
	public String toString() {
		String s = "Serious Error";
		if (getMessage() != null) {
			String prefix = s + ": ";
			s = prefix + getMessage().replace(prefix, "");
		}
		return s;
	}

}
