package com.otk.application.image.filter;

import java.awt.Color;
import java.util.LinkedHashMap;
import java.util.Map;

public class OptimizationCache {

	private Map<Object, Color> map = new LinkedHashMap<Object, Color>();
	private int maximumSize = 1000;

	public OptimizationCache(int maximumSize) {
		super();
		this.maximumSize = maximumSize;
	}

	public OptimizationCache() {
		this(1000);
	}

	public synchronized Color get(Object key) {
		return map.get(key);
	}

	public synchronized void put(Object key, Color newPixelColor) {
		if (map.putIfAbsent(key, newPixelColor) == null) {
			if (map.size() > maximumSize) {
				Object firstKey = map.keySet().iterator().next();
				map.remove(firstKey);
			}
		}
	}

	public synchronized void clear() {
		map.clear();
	}

}