package com.otk.application.image.filter;

import java.awt.Graphics2D;
import java.awt.image.BufferedImage;

import javax.swing.JPanel;

import com.otk.application.translation.T;
import com.otk.application.util.ImageUtils;
import com.otk.application.window.component.crud.ICrudItemControlListener;

public class VerticalFlip extends AbstractFilter {

	@Override
	public String getCaption() {
		return T.t("Flip vertically");
	}

	@Override
	public void createFieldControls(JPanel panel, ICrudItemControlListener listener) {
	}

	@Override
	protected FilteringContext doExecute(FilteringContext context) {
		BufferedImage inputImage = context.getImage();
		int width = inputImage.getWidth(null);
		int height = inputImage.getHeight(null);
		BufferedImage dstImage = new BufferedImage(width, height, ImageUtils.getAdaptedBufferedImageType());
		Graphics2D g2d = dstImage.createGraphics();
		g2d.translate(0, height);
		g2d.scale(1, -1);
		g2d.drawImage(inputImage, 0, 0, null);
		g2d.dispose();
		return context.withImage(dstImage);
	}

}
