package com.otk.application.util;

import java.util.HashMap;
import java.util.Map;

public class Counter {

	private static Map<Object, Long> countByKey = new HashMap<Object, Long>();

	public synchronized static long next(Object key) {
		if (!countByKey.containsKey(key)) {
			countByKey.put(key, 0l);
		}
		long lastCount = countByKey.get(key);
		long newCount;
		if (lastCount == Long.MAX_VALUE) {
			newCount = 0;
		} else {
			newCount = lastCount + 1;
		}
		countByKey.put(key, newCount);
		return lastCount;
	}

	public synchronized static long getCurrent(Object key) {
		return countByKey.get(key);
	}

}
