package com.otk.application.util.draw;

import java.awt.Graphics2D;
import java.awt.Rectangle;

import com.otk.application.util.MathUtils;

public class Grid {

	private int columnCount;
	private int rowCount;
	private int width;
	private int height;

	public Grid(int columnCount, int rowCount, int width, int height) {
		this.columnCount = columnCount;
		this.rowCount = rowCount;
		this.width = width;
		this.height = height;
	}

	public void drawBorder(Graphics2D g2d) {
		g2d.drawRect(0, 0, width - 1, height - 1);
	}

	public void drawLines(Graphics2D g2d) {
		int x1, y1, x2, y2;
		for (int i = 0; i < columnCount - 1; i++) {
			x1 = getCell(i + 1, 0).x;
			y1 = 0;
			x2 = x1;
			y2 = height;
			g2d.drawLine(x1, y1, x2, y2);
		}
		for (int i = 0; i < rowCount - 1; i++) {
			x1 = 0;
			y1 = getCell(0, i + 1).y;
			x2 = width;
			y2 = y1;
			g2d.drawLine(x1, y1, x2, y2);
		}
	}

	public Rectangle getCell(int column, int row) {
		int x1 = MathUtils.round(column * (double) width / columnCount);
		int x2 = MathUtils.round((column + 1) * (double) width / columnCount);
		int y1 = MathUtils.round(row * (double) height / rowCount);
		int y2 = MathUtils.round((row + 1) * (double) height / rowCount);
		Rectangle result = new Rectangle();
		result.x = x1;
		result.y = y1;
		result.width = x2 - x1;
		result.height = y2 - y1;
		return result;
	}
}
