package com.otk.application.window.component;

import java.awt.AlphaComposite;
import java.awt.Composite;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Rectangle;

import javax.swing.JComponent;

public class TranslucentGlassPane extends JComponent{

	private static final long serialVersionUID = 1L;
	private float opacity = 1.0f;

	public TranslucentGlassPane() {
		setVisible(true);
	}

	public float getOpacity() {
		return opacity;
	}

	public void setOpacity(float opacity) {
		this.opacity = opacity;
	}

	@Override
	protected void paintComponent(Graphics g) {
		Graphics2D g2 = (Graphics2D) g;
		Rectangle clip = g.getClipBounds();
		AlphaComposite alphaComposite = AlphaComposite.SrcOver.derive(opacity);
		Composite initialComposite = g2.getComposite();
		g2.setComposite(alphaComposite);
		g2.setColor(getBackground());
		g2.fillRect(clip.x, clip.y, clip.width, clip.height);
		g2.setComposite(initialComposite);
	}
}
