package com.otk.application.window.component.crud;

import java.lang.reflect.Field;
import java.lang.reflect.Modifier;
import java.util.ArrayList;
import java.util.List;

import com.otk.application.util.MiscUtils;

public abstract class AbstractPojoWrapperCrudItem<W> extends AbstractCrudItem {

	private W wrapped;

	protected abstract W createWrapped();

	protected AbstractPojoWrapperCrudItem() {
		wrapped = createWrapped();
	}

	
	public W getWrapped() {
		return wrapped;
	}

	public void setWrapped(W wrapped) {
		this.wrapped = wrapped;
	}

	@Override
	protected void setFieldValue(String fieldName, Object filedValue) {
		MiscUtils.setFieldValue(wrapped, fieldName, filedValue);
	}

	@Override
	protected Object getFieldValue(String name) {
		return MiscUtils.getFieldValue(wrapped, name);
	}
	
	@Override
	public String[] getFieldNames() {
		List<String> result = new ArrayList<String>();
		for(Field field: wrapped.getClass().getFields()){
			if (Modifier.isStatic(field.getModifiers())) {
				continue;
			}
			result.add(field.getName());
		}
		return result.toArray(new String[result.size()]);
	}

	

	@Override
	public String writeFields() {
		return MiscUtils.saveFieldValuesLine(getFieldNames(), wrapped);
	}

	@Override
	public void readFields(String line) {
		MiscUtils.loadFieldValuesLine(line, getFieldNames(), wrapped);
	}

}
